package com.xuqm.server.appmanager.common;

import com.auth0.jwt.JWT;
import com.auth0.jwt.JWTCreator;
import com.auth0.jwt.algorithms.Algorithm;
import com.auth0.jwt.interfaces.DecodedJWT;
import com.xuqm.server.appmanager.entitys.UserInfo;
import com.xuqm.server.appmanager.entitys.sys.v1.TenantUserEntity;

import java.util.Calendar;

public class JWTHelper {
    //定义自己的密钥
    private static final String TOKEN = "token!DASD(#$dsad%$#.";

    /**
     * 生成token
     *
     * @param user 传入的有效负荷
     * @return
     */
    public static String genToken(TenantUserEntity user) {
        JWTCreator.Builder builder = JWT.create();
        builder.withClaim("userId", user.getUserId());
        builder.withClaim("tenantNo", user.getTenantNo());
        Calendar instance = Calendar.getInstance();
        //定义过期时间
        instance.add(Calendar.DATE, 7);
        builder.withExpiresAt(instance.getTime());
        return builder.sign(Algorithm.HMAC256(TOKEN));
    }

    /**
     * 验证获取token中的有效负载，验证失败返回null
     *
     * @param token
     * @return
     */
    public static DecodedJWT verify(String token) {
        return JWT.require(Algorithm.HMAC256(TOKEN)).build().verify(token);
    }

    public static UserInfo getUser(String token) {
        DecodedJWT jwt = null;
        try {
            jwt = JWTHelper.verify(token);
        } catch (Exception ignored) {
            return null;
        }
        return new UserInfo(jwt.getClaim("userId").asString(), jwt.getClaim("tenantNo").asString());
    }
}
