package com.xuqm.server.appmanager.controller.user.v1;

import com.xuqm.server.appmanager.common.JWTHelper;
import com.xuqm.server.appmanager.entitys.UserLogin;
import com.xuqm.server.appmanager.entitys.sys.v1.TenantUserEntity;
import com.xuqm.server.appmanager.http.HttpResult;
import com.xuqm.server.appmanager.repository.sys.v1.ApplicationRepository;
import com.xuqm.server.appmanager.repository.sys.v1.TenantRepository;
import com.xuqm.server.appmanager.repository.sys.v1.TenantUserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("user/v1")
public class UserV1Controller {

    @Autowired
    private TenantRepository tenantRepository;
    @Autowired
    private TenantUserRepository tenantUserRepository;
    @Autowired
    private ApplicationRepository applicationRepository;

    @PostMapping("/login")
    public HttpResult<String> userLogin(@RequestBody UserLogin user) throws Exception {
        if (null == user.getEmail() ||
                null == user.getPassword()) {
            return new HttpResult<>(201, "参数错误", null);
        } else {
            TenantUserEntity u = tenantUserRepository.findFirstByUserEmailAndUserPwd(user.getEmail(), user.getPassword());

            if (u == null) {
                return new HttpResult<>(501, "用户名或密码错误", null);
            }

            return new HttpResult<>(200, "登录成功", JWTHelper.genToken(u));
        }

    }
}
